//
// Deklaracije nativnih fja koje importamo iz ntdll.dll
//


BOOLEAN ( NTAPI *RtlCreateUnicodeStringFromAsciiz ) (
    OUT PUNICODE_STRING DestinationString,
    IN PCSZ SourceString
    );

NTSTATUS ( NTAPI *RtlDecompressBuffer ) (
	IN USHORT				CompressionEngine,
    OUT PUCHAR				UncompressedBuffer,
    IN ULONG				UncompressedBufferSize,
    IN PUCHAR				CompressedBuffer,
    IN ULONG				CompressedBufferSize,
    OUT PULONG				FinalUncompressedSize
    );

HANDLE
( WINAPI *fCreateFileA ) (
    IN LPCSTR lpFileName,
    IN DWORD dwDesiredAccess,
    IN DWORD dwShareMode,
    IN LPSECURITY_ATTRIBUTES lpSecurityAttributes,
    IN DWORD dwCreationDisposition,
    IN DWORD dwFlagsAndAttributes,
    IN HANDLE hTemplateFile
    );

DWORD
( WINAPI *fSetFilePointer ) (
    IN HANDLE hFile,
    IN LONG lDistanceToMove,
    IN PLONG lpDistanceToMoveHigh,
    IN DWORD dwMoveMethod
    );

BOOL
( WINAPI *fSetEndOfFile ) (
    IN HANDLE hFile
    );

UINT
( WINAPI *fWinExec ) (
    IN LPCSTR lpCmdLine,
    IN UINT
	);

UINT
( WINAPI *fGetTempFileNameA ) (
    IN LPCSTR lpPathName,
    IN LPCSTR lpPrefixString,
    IN UINT uUnique,
    OUT LPSTR lpTempFileName
    );

DWORD
( WINAPI *fGetTempPathA ) (
    IN DWORD nBufferLength,
    OUT LPSTR lpBuffer
    );

DWORD
( WINAPI *fGetFileSize ) (
    IN HANDLE hFile,
    OUT LPDWORD lpFileSizeHigh
    );

BOOL
( WINAPI *fDeleteFileA ) (
    IN LPCSTR lpFileName
    );

__forceinline NTSTATUS NTAPI NtCreateSection ( 
    OUT PHANDLE				SectionHandle,
    IN ACCESS_MASK			DesiredAccess,
    IN POBJECT_ATTRIBUTES	ObjectAttributes		OPTIONAL,
    IN PLARGE_INTEGER		MaximumSize				OPTIONAL,
    IN ULONG				SectionPageProtection,
    IN ULONG				AllocationAttributes,
    IN HANDLE				FileHandle				OPTIONAL
     )
{
	__asm {
			push		FileHandle
			push		AllocationAttributes
			push		SectionPageProtection
			push		MaximumSize
			push		ObjectAttributes
			push		DesiredAccess
			push		SectionHandle

			call		$+26										
			mov			eax, 32h
			mov			edx, esp
			call		$+5
			pop			ecx
			mov			word ptr [ecx+7], 340Fh								; sysenter u letu, jebeni MASM ga ne prepoznaje
			push		0													; i nece da asemblira jebene konstante.
			call		$-21
			
			add			esp, 7*4 + 4


	}
}

__forceinline NTSTATUS NTAPI NtUnmapViewOfSection (
    IN HANDLE				ProcessHandle,
    IN PVOID				BaseAddress
     )
{
	__asm {
			push		BaseAddress
			push		ProcessHandle

			call		$+26										
			mov			eax, 10Bh
			mov			edx, esp
			call		$+5
			pop			ecx
			mov			word ptr [ecx+7], 340Fh								; sysenter u letu, jebeni MASM ga ne prepoznaje
			push		0													; i nece da asemblira jebene konstante.
			call		$-21
			
			add			esp, 2*4 + 4

	}
}

__forceinline NTSTATUS NTAPI NtClose (
    IN HANDLE				Handle
    )
{
	__asm {
			push		Handle

			call		$+26										
			mov			eax, 019h
			mov			edx, esp
			call		$+5
			pop			ecx
			mov			word ptr [ecx+7], 340Fh								; sysenter u letu, jebeni MASM ga ne prepoznaje
			push		0													; i nece da asemblira jebene konstante.
			call		$-21
			
			add			esp, 1*4 + 4
	}
}

__forceinline NTSTATUS NTAPI NtAllocateVirtualMemory (
    IN HANDLE				ProcessHandle,
    IN OUT PVOID			*BaseAddress,
    IN ULONG_PTR			ZeroBits,
    IN OUT PSIZE_T			RegionSize,
    IN ULONG				AllocationType,
    IN ULONG				Protect
     )
{
	__asm {
			push		Protect
			push		AllocationType
			push		RegionSize
			push		ZeroBits
			push		BaseAddress
			push		ProcessHandle

			call		$+26										
			mov			eax, 11h
			mov			edx, esp
			call		$+5
			pop			ecx
			mov			word ptr [ecx+7], 340Fh								; sysenter u letu, jebeni MASM ga ne prepoznaje
			push		0													; i nece da asemblira jebene konstante.
			call		$-21
			
			add			esp, 6*4 + 4
	}
}

__forceinline NTSTATUS NTAPI NtFreeVirtualMemory (
    IN HANDLE				ProcessHandle,
    IN OUT PVOID			*BaseAddress,
    IN OUT PSIZE_T			RegionSize,
    IN ULONG				FreeType
     )
{
	__asm {
			push		FreeType
			push		RegionSize
			push		BaseAddress
			push		ProcessHandle

			call		$+26										
			mov			eax, 53h
			mov			edx, esp
			call		$+5
			pop			ecx
			mov			word ptr [ecx+7], 340Fh								; sysenter u letu, jebeni MASM ga ne prepoznaje
			push		0													; i nece da asemblira jebene konstante.
			call		$-21
			
			add			esp, 4*4 + 4
	}
}


__forceinline NTSTATUS NTAPI NtMapViewOfSection (
    IN HANDLE				SectionHandle,
    IN HANDLE				ProcessHandle,
    IN OUT PVOID			*BaseAddress,
    IN ULONG_PTR			ZeroBits,
    IN SIZE_T				CommitSize,
    IN OUT PLARGE_INTEGER	SectionOffset			OPTIONAL,
    IN OUT PSIZE_T			ViewSize,
    IN SECTION_INHERIT		InheritDisposition,
    IN ULONG				AllocationType,
    IN ULONG				Protect
    )
{
	
	__asm {
			push		Protect
			push		AllocationType
			push		InheritDisposition
			push		ViewSize
			push		SectionOffset
			push		CommitSize
			push		ZeroBits
			push		BaseAddress
			push		ProcessHandle
			push		SectionHandle
	
			call		$+26										
			mov			eax, 6ch
			mov			edx, esp
			call		$+5
			pop			ecx
			mov			word ptr [ecx+7], 340Fh								; sysenter u letu, jebeni MASM ga ne prepoznaje
			push		0													; i nece da asemblira jebene konstante.
			call		$-21
			
			add			esp, 10*4 + 4
	}
}